/********************************************************
 * unit -- Convert from one unit to another.		*
 *							*
 * Programming problem: 7-1.				*
 *							*
 * Usage:						*
 *	run the program					*
 *		enter the conversion number		*
 *		receive the answer			*
 *	     repeat until done.				*
 *							*
 * Conversions:						*
 *		mile -> kilometer			*
 *		kilometer -> mile			*
 *		inch -> cm				*
 *		cm -> inch				*
 *		gallon -> liter				*
 *		liter -> gallon				*
 *		kilogram -> pound			*
 *		pound -> kilogram			*
 *							*
 * Note: Conversion numbers come from the UNIX "units"	*
 * command.						*
 ********************************************************/
#include <iostream.h>

/*
 * These are the names of the units.  They come in pairs.  Each
 * pair has a corresponding entry in the conversions array that
 * converts the first item to the second.
 */
char unit_names[][20] = {
   "miles",	"kilometers",
   "inches",	"centimeters",
   "gallons",	"liters",
   "kilograms",	"pounds",
   "",		""
};

/*
 * There is one entry in this array for each pair of names in
 * the unit_names.  This number converts the first unit to the
 * second.
 */
float conversions[] = {
    1.609344e+00,		/* mile -> km */
    2.540000e+00,		/* inch -> cm */
    3.785412e+00,		/* Gallon -> Liter */
    2.204623e+00		/* kg -> lb. */
};

float convert_from;	// Number we convert from
float convert_to;	// Result of the conversion
int from_index;		// Index into unit_names of from units
int to_index;		// Index into unit_names of to units
int conversion_index;	// Index into table for printing prompt
int conversion_number;	// Conversion selected by the user
    
main()
{
    while (1) {
	conversion_index = 0;

	while (unit_names[conversion_index][0] != '\0') {
	    // Write out the forward conversion
	    cout << (conversion_index) + 1 << ": " <<
		unit_names[conversion_index] << " to " << 
		unit_names[conversion_index+1] << '\n';

	    // Write out the backward conversion
	    cout << (conversion_index) + 2 << ": " <<
		unit_names[conversion_index+1] << " to " << 
		unit_names[conversion_index] << '\n';
	    conversion_index += 2;
	}
	cout << "Enter conversion number or -1 to exit: ";
	cin >> conversion_number;

	// If too low, get out
	if (conversion_number < 1)
	    break;

	if (conversion_number >= conversion_index) {
	    cout << "Illegal conversion number " << conversion_number << '\n';
	} else {
	    cout << "Enter " << unit_names[conversion_number-1] << ": ";
	    cin >> convert_from;

	    if ((conversion_number % 2) == 1) {
		from_index = (conversion_number-1) / 2;
		to_index = from_index + 1;
		convert_to = 
		    convert_from * conversions[(conversion_number-1)/2];
	    } else {
		from_index = (conversion_number-1) / 2 + 1;
		to_index = from_index - 1;
		convert_to = 
		    convert_from / conversions[(conversion_number-1)/2];
	    }

	    cout << convert_from << ' ' << unit_names[from_index] << 
		   " is " << convert_to << ' ' << unit_names[to_index] << '\n';
	    cout << '\n';
	}
    }
    return (0);
}
