/********************************************************
 * expand -- expand spaces into tabs			*
 *							*
 * Programming Problem: 16-2				*
 *							*
 * Usage:						*
 * 	expand <in_file> <out_file>			*
 *							*
 * Note: Tab stops are fixed at 8 characters.		*
 ********************************************************/
#include <iostream.h>
#include <fstream.h>

const int TAB_STOP = 8;	// Tab size

main(int argc, char *argv[])
{
    if (argc != 3) {
	cerr << "Usage is expand <in_file> <out_file>\n";
	exit (8);
    }

    // File we are reading
    ifstream in_file(argv[1]);	 

    if (in_file.bad()) {
	cerr << "Error: Can not open " << argv[1] << " for input\n";
	exit (8);
    }
	 
    // File we are writing
    ofstream out_file(argv[2]);	 

    if (out_file.bad()) {
	cerr << "Error: Can not open " << argv[2] << " for output\n";
	exit (8);
    }

    char ch;	// Current character
    int  cur_col = 0;	// Current column

    while (!in_file.eof()) {
	in_file.get(ch);

	switch (ch) {
	    case '\b':	// Backspace
		--cur_col;
		out_file << ch;
		break;
	    case '\t':
		out_file << ' ';
		++cur_col;

		while ((cur_col % 8) != 0) {
		    out_file << ' ';
		    ++cur_col;
		}
		break;
	    case '\n':
		cur_col = 0;
		out_file << ch;
		break;
	    default:
		if (ch >= ' ') {
		    out_file << ch;
		    ++cur_col;
		}
		break;
	}
    }
    return (0);
}
		    


	 
