/********************************************************
 * lines -- count the number of lines in a file		*
 *							*
 * Programming Problem: 16-1				*
 *							*
 * Usage:						*
 *	lines <file-list>				*
 *							*
 * If no files are specified, cin is used.		*
 ********************************************************/
#include <iostream.h>
#include <fstream.h>

/********************************************************
 * count_one -- count # lines in a single file		*
 *							*
 * Returns the number of lines				*
 ********************************************************/
int count_one(
    istream &in_file	// File to read
)
{
    int count = 0;	// Line counter

    while (!in_file.eof()) {
	char ch;	// Character we are looking at

	in_file.get(ch);
	if (in_file.eof())
	    break;

	if (ch == '\n')
	    ++count;
    }
    return (count);
}

main(int argc, char *argv[])
{
    if (argc == 1) {
	cout << count_one(cin) << "\t--cin--\n";
    } else {
	while (argc > 1) {
	    ifstream in_file(argv[1]);	// Input file

	    if (in_file.bad()) {
		cerr << "Error: Could not open " << argv[1] << 
			" for reading\n";
	    } else {
		cout << count_one(in_file) << '\t' << argv[1] << '\n';
	    }
	    argc--;
	    argv++;
	}
    }
    return (0);
}

