/********************************************************
 * strip -- strip the high bit off a text file		*
 *							*
 * Programming Problem: 16-5.				*
 *							*
 * Usage:						*
 *	strip <in-file> <out-file>			*
 ********************************************************/
#include <iostream.h>
#include <fstream.h>

main(int argc, char *argv[])
{
    if (argc != 3) {
	cout << "Usage is: strip <in_file> <out_file>\n";
	exit (8);
    }

    // Input file
    ifstream in_file(argv[1], ios::bin|ios::in);

    if (in_file.bad()) {
	cerr << "Error: Could not open " << argv[1] << " for input\n";
	exit (8);
    }

    // Output file
    ofstream out_file(argv[2], ios::bin|ios::out);

    if (out_file.bad()) {
	cerr << "Error: Could not open " << argv[2] << " for output\n";
	exit (8);
    }

    while (1) {
	char cur_char;	// Character we are working on

	in_file.read(&cur_char, sizeof(cur_char));
	if (in_file.eof())
	    break;
	
	cur_char &= 0x7F;	// Strip high big

	out_file.write(&cur_char, sizeof(cur_char));
    }
    return (0);
}
    


