/********************************************************
 * bit -- bit counting routines				*
 *							*
 * Programming Problem: 17-4				*
 ********************************************************/
#include <iostream.h>

/********************************************************
 * bit_count -- count bits (unoptimized)		*
 *							*
 * Returns:						*
 *	number of bits set.				*
 ********************************************************/
int bit_count(
    char *data			// Data to count
) {
    int i;		// Random index
    int bit;		// Bit index
    int sum = 0;	// Running sum

    for (i = 0; data[i] != '\0'; ++i) {
       for (bit = 1; bit <= 0x80; bit <<= 1) {
	   if ((data[i] & bit) != 0)
	       ++sum;
	}
    }
    return (sum);
}


/********************************************************
 * bit_count2 -- count bits 				*
 *							*
 * Returns:						*
 *	number of bits set.				*
 ********************************************************/
int bit_count2(
    register char *data			// Data to count
) {
    register int bit;		// Bit index
    register int sum = 0;	// Running sum

    for (/* data set */; *data != '\0'; ++data) {
       register char ch = *data;
       for (bit = 1; bit <= 0x80; bit <<= 1) {
	   if ((ch & bit) != 0)
	       ++sum;
	}
    }
    return (sum);
}

#include "test_txt.h"

main(int argc, char *argv[])
{
    if (argc != 2) {
	cerr << "Usage is bit <1 or 2>\n";
	exit(8);
    }
    int i;	// General purpose counter

    switch (argv[1][0]) {
	 case '1':
	     cout << "Unoptimized version\n";
	     cout << "Count is " << bit_count(text) << '\n';
	     cout << "Timing\n";
	     for (i = 0; i < 1000; ++i)
		 bit_count(text);
	     break;
	 case '2':
	     cout << "Optimized version\n";
	     cout << "Count is " << bit_count2(text) << '\n';
	     cout << "Timing\n";
	     for (i = 0; i < 1000; ++i)
		 bit_count2(text);
	     break;
	 default:
	     cerr << "Error: Illegal argument\n";
	     break;
    }
    return (0);
}
