/********************************************************
 * shape -- demonstrate a shape class.			*
 *							*
 * Programming Problem: 21-3.				*
 ********************************************************/
#include <iostream.h>
#include <math.h>

// #### Add comments
class shape {
    public:
        float size;	// Size of the object

	// Constructor defaults
	// Destructor defaults
	// Copy constructor defaults
	// Assignment operator defaults

	virtual double area(void) = 0;
	virtual const char *const name(void) = 0;
};
class square:public shape {
    public:
        double area(void) {
	    return (size * size);
	}
	const char *const name(void) {
	    return ("square");
	}
};

class circle:public shape {
    public:
        double area(void) {
	    return (M_PI * size * size);
	}
	const char *const name(void) {
	    return ("circle");
	}
};

class triangle:public shape {
    public:
        double area(void) {
	    return (0.5 * size * size);
	}
	const char *const name(void) {
	    return ("triangle");
	}
};


void print(
    shape &a_shape
) {
    cout << "Area of a " << a_shape.name() << 
            " is " << a_shape.area() << '\n';
}
main()
{
    circle a_circle;
    triangle a_triangle;
    square a_square;

    a_circle.size = 2.0;
    a_triangle.size = 2.0;
    a_square.size = 2.0;

    print(a_circle);
    print(a_triangle);
    print(a_square);

    return (0);
}
