/********************************************************
 * letter -- function to counter letters/digits		*
 *		and test routine.			*
 *							*
 * Programming Problem: 22-4				*
 ********************************************************/
#include <iostream.h>
#include <ctype.h>

class letter_error {
    public:
        char bad_char;	// Offending character

        letter_error(const char i_char) {
	    bad_char = i_char;
	}
	// Destructor defaults
	// Copy constructor defaults
	// Assignment operator defaults
};
/********************************************************
 * counter_letters -- count letters, digits in a string *
 *							*
 * Causes a "letter_error" exception if bad input.	*
 ********************************************************/
void count_letters(
    const char str[],	// String containing data to count
    int &letter_count,	// Number of letters
    int &digit_count	// Number of digits
) throw(letter_error) {
    const char *cur_char;	// Character we are looking at

    letter_count = 0;
    digit_count = 0;
    for (cur_char = str; *cur_char != '\0'; ++cur_char) {
	if (isalpha(*cur_char))
	    ++letter_count;
	else if (isdigit(*cur_char)) 
	    ++digit_count;
	else throw(letter_error(*cur_char));
    }
}

main()
{
    int letter_count;	// # letters in a string
    int digit_count;	// # digits in a string

    try {
	count_letters("123abc", letter_count, digit_count);
	cout << "Letters: " << letter_count << 
	        " Digits: " << digit_count << '\n';

	count_letters("123abc+", letter_count, digit_count);
	cout << "Letters: " << letter_count <<
	        " Digits: " << digit_count << '\n';
    } 

    catch (letter_error &err) {
        cout << "Bad character: " << err.bad_char << '\n';
    }
    return (0);
}

	

