/********************************************************
 * mail -- define the mailing list structure		*
 ********************************************************/
#ifndef _MAIL_H_	// Prevent double includes
#define _MAIL_H_	

const int WIDTH = 50;	// Width of the mailing label

const int ZIP_WIDTH = 5;	// Width of a zip code
const int STATE_WIDTH = 2;	// Width of a state code
// The three (2) in the following are for spaces and a comma
// Width of the city name
const int CITY_WIDTH = WIDTH - 1 -1 - STATE_WIDTH - 1 - ZIP_WIDTH;

// The +1 in the following are for end of string characters
// Mailing list entry
struct mail {
    char name[WIDTH+1];		// Name of the person
    char address1[WIDTH+1];	// Address line 1
    char address2[WIDTH+1];	// Address line 2

    char city[CITY_WIDTH+1];	// City name
    char state[STATE_WIDTH+1];	// State
    char zip[ZIP_WIDTH+1];	// Zip code
    unsigned long int  zip_number;// Numeric version of the zip code
};

const int NAME_MAX = 200;	// Max mailing list size
				// (Very small)

extern mail *mail_list[NAME_MAX];	// Mailing list data
extern unsigned int n_mail;		// Number of entries in the list

#endif /* _MAIL_H_ */	
